<script setup lang="ts">
import S3KeyView from "@/views/object-storage/S3KeyView.vue";
import FontAwesomeIcon from "@/components/FontAwesomeIcon.vue";
import { reactive, onMounted, computed } from "vue";
import { useUserStore } from "@/stores/users";
import { Toast, Tooltip } from "bootstrap";
import { useS3KeyStore } from "@/stores/s3keys";
import BootstrapToast from "@/components/BootstrapToast.vue";
import { useSettingsStore } from "@/stores/settings";

const authStore = useUserStore();
const keyRepository = useS3KeyStore();
const settingsStore = useSettingsStore();

let successToast: Toast | null = null;
let refreshTimeout: NodeJS.Timeout | undefined = undefined;
let addTimeout: NodeJS.Timeout | undefined = undefined;

const keyState = reactive<{
  activeKey: number;
  initialLoading: boolean;
  deletedKey: string;
}>({
  activeKey: 0,
  initialLoading: true,
  deletedKey: "",
});

const allowKeyDeletion = computed<boolean>(() => keyRepository.keys.length > 1);

function fetchKeys() {
  keyRepository
    .fetchS3Keys(() => (keyState.initialLoading = false))
    .then((keys) => {
      if (keyState.activeKey >= keys.length) {
        keyState.activeKey = keys.length - 1;
      }
    })
    .catch((err) => console.error(err));
}

function refreshKeys() {
  clearTimeout(refreshTimeout);
  refreshTimeout = setTimeout(() => {
    fetchKeys();
  }, 500);
}

function deleteKey(accessKey: string) {
  if (allowKeyDeletion.value && authStore.authenticated) {
    keyRepository
      .deleteS3Key(accessKey)
      .then(() => {
        keyState.activeKey = 0;
        keyState.deletedKey = accessKey;
        successToast?.show();
      })
      .catch((err) => console.error(err));
  }
}

function createKey() {
  clearTimeout(addTimeout);
  addTimeout = setTimeout(() => {
    if (authStore.authenticated) {
      keyRepository.createS3Key().catch((err) => console.error(err));
    }
  }, 500);
}

onMounted(() => {
  successToast = new Toast("#successKeyToast");
  if (authStore.authenticated) {
    fetchKeys();
  }
  new Tooltip("#createS3KeyButton");
  new Tooltip("#refreshS3KeysButton");
});
</script>

<template>
  <bootstrap-toast toast-id="successKeyToast">
    Successfully deleted S3 Key {{ keyState.deletedKey }}
  </bootstrap-toast>
  <div class="row border-bottom mt-4">
    <div class="col-12"></div>
    <h2 class="mb-2">S3 Keys</h2>
  </div>
  <div class="row mt-4">
    <div class="col-4">
      <div class="d-flex justify-content-between mb-4">
        <button
          id="refreshS3KeysButton"
          type="button"
          class="btn border shadow-sm"
          :class="{
            'btn-light': settingsStore.lightThemeActive,
            'btn-secondary': settingsStore.darkThemeActive,
          }"
          data-bs-title="Refresh S3 Keys"
          data-bs-toggle="tooltip"
          @click="refreshKeys()"
        >
          <font-awesome-icon
            icon="fa-solid fa-arrow-rotate-right"
            class="fs-5"
          />
          <span class="visually-hidden">Refresh S3 Keys</span>
        </button>
        <button
          id="createS3KeyButton"
          type="button"
          class="btn border shadow-sm"
          :class="{
            'btn-light': settingsStore.lightThemeActive,
            'btn-secondary': settingsStore.darkThemeActive,
          }"
          data-bs-title="Create S3 Key"
          data-bs-toggle="tooltip"
          @click="createKey"
        >
          <font-awesome-icon icon="fa-solid fa-plus" class="fs-5" />
          <span class="visually-hidden">Create S3 Key</span>
        </button>
      </div>
      <div v-if="keyState.initialLoading" class="placeholder-glow">
        <a
          v-for="n in 3"
          :key="n"
          type="button"
          aria-hidden="true"
          class="btn w-100 fs-5 mb-3 btn-secondary disabled placeholder"
        />
      </div>
      <div v-else class="d-grid gap-3">
        <button
          v-for="(s3key, index) in keyRepository.keys"
          :key="s3key.access_key"
          class="btn fs-5 text-truncate border hover-shadow"
          type="button"
          :class="{
            'btn-light': keyState.activeKey !== index,
            'btn-primary': keyState.activeKey === index,
            shadow: keyState.activeKey === index,
          }"
          @click="keyState.activeKey = index"
        >
          {{ s3key.access_key.slice(0, 8) }}...
        </button>
      </div>
    </div>
    <div class="col-7 offset-md-1">
      <s3-key-view
        v-if="keyRepository.keys.length > 0 || keyState.initialLoading"
        :s3key="
          keyState.initialLoading
            ? { uid: '', access_key: '', secret_key: '' }
            : (keyRepository.keys[keyState.activeKey] ?? keyRepository.keys[0])
        "
        :deletable="allowKeyDeletion"
        :loading="keyState.initialLoading"
        @delete-key="deleteKey"
      />
      <div v-else>
        No keys here. <br />
        Create a new Key to interact with your Buckets again.
      </div>
    </div>
  </div>
</template>

<style scoped></style>
